package jp.oarts.pirka.sample.instruction.is101900;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.io.ByteArrayOutputStream;
import java.io.IOException;

import javax.imageio.ImageIO;

import jp.oarts.pirka.core.kernel.PirkaImage;

/**
 * pirkatTv IC[W̍ C[W`NX
 */
class ImageDrawSample extends PirkaImage {

	/**	ۂ̕`	*/
	int count;

	/**
	 * RXgN^
	 * @param count	ۂ̕`
	 */
	public ImageDrawSample(int count) {
		this.count = count;
	}

	/**
	 * C[WoCgz擾܂
	 * 
	 * @return	oCgz
	 */
	@Override
	public byte[] getImage() throws IOException {
		int width = 300;
		int height = 300;

		BufferedImage img = new BufferedImage(width, height, BufferedImage.TYPE_3BYTE_BGR);
		ByteArrayOutputStream baos = null;
		Graphics2D g = null;
		try {
			g = (Graphics2D) img.createGraphics();
			paint(g, width, height, count);
			baos = new ByteArrayOutputStream();
			ImageIO.write(img, "png", baos);
			baos.flush();

		} finally {
			if (g != null) {
				g.dispose();
				g = null;
			}
			img = null;
			if (baos != null) {
				baos.close();
			}
		}
		return baos.toByteArray();

	}

	/**
	 * C[W`悵܂
	 * @param g2			OtBN2D
	 * @param width		
	 * @param height		c
	 * @param drawCount	̕`搔
	 */
	private void paint(Graphics2D g2, int width, int height, int drawCount) {

		int r = 20;
		g2.setColor(new Color(0, 0, 0));
		g2.fillRect(0, 0, width, height);

		for (int i = 0; i < drawCount; i++) {
			switch ((int) (4 * Math.random())) {
			case 0:
				g2.setColor(new Color(0xff, 0xc0, 0xc0));
				break;
			case 1:
				g2.setColor(new Color(0xc0, 0xff, 0xc0));
				break;
			case 2:
				g2.setColor(new Color(0xc0, 0xc0, 0xff));
				break;
			case 3:
				g2.setColor(new Color(0xf0, 0xf0, 0xf0));
				break;
			}

			int x = (int) ((width - r) * Math.random());
			int y = (int) ((height - r) * Math.random());
			g2.fillOval(x, y, r, r);
		}
	}

	/**
	 * ̃NXC[WMIME^Cv擾܂
	 * 
	 *  @return	MIME^Cv
	 */
	@Override
	public String getMimeType() {
		return PirkaImage.MIME_TYPE_PNG;
	}
}
